% Example-29: Understanding the data structures of 
%      basic elements in GPenSIM
% Reggie.davidrajuh@uis.no  (c) 20 Nov 2017

function [fire, transition] = COMMON_PRE(transition)
global PN
global global_info
 
ctime = current_time;
check_up_time = eq(ctime, 4);
 
%%%%%%%%%%%%%%%%%% 
% Print the data structure of p2, p3, tA 
if check_up_time
    disp(['Enabled transitions is: ', transition.name]);
    disp(' '); disp('The global PN dynamic structure:'); disp(PN);
    disp(' '); disp('Structure of the place "p2":');   
    disp(PN.global_places(2));
    disp('Structure of the place "p3":'); disp(PN.global_places(3));
    disp('Structure of the token bank at "p2":'); 
    for i = 1:length(PN.global_places(2).token_bank)
        disp(PN.global_places(2).token_bank(i));
    end
    disp(' '); 
    disp('Structure of the transition "tA" before aquiring resources:'); 
    disp(PN.global_transitions(1));
end
%%%%%%%%%%%%%%%%%%     
    
if strcmpi(transition.name, 'tA')
    granted = requestSR({'rX',1, 'rY',1});
elseif strcmpi(transition.name, 'tB')
    granted = requestSR({'rY',1, 'rZ',2});    
end
 
if check_up_time
    disp(' '); 
    disp('Structure of "tA" after aquiring resources:'); 
    disp(PN.global_transitions(1));
end   
 
global_info.check_up_time = check_up_time;

fire = granted;
