% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-29: Understanding the data structures of 
%      basic elements in GPenSIM
% Reggie.davidrajuh@uis.no  (c) 20 Nov 2017
% MSF: 

clear all; clc;
global global_info
global_info.check_up_time = false;
global_info.STOP_AT = 18;
 
pns = pnstruct('datastructure_pdf');
 
dyn.m0 = {'p1',6}; % tokens initially
dyn.ft = {'tA',1, 'tB',2}; 
dyn.fc_fixed =  {'tA',1000, 'tB',500};
dyn.fc_variable={'tA',100,  'tB',50};
 
dyn.re = {'rX',1,inf, 'rY',2,inf, 'rZ',3,inf};
dyn.rc_fixed = {'rX',110, 'rY',120, 'rZ',130};
dyn.rc_variable = {'rX',10, 'rY',20, 'rZ',30};
 
pni = initialdynamics(pns, dyn);
sim = gpensim(pni);
